/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2018 - 2024 Johannes Schneider, Dominik Schnier, Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.shared.usergeneratedcontentflag.clientmodel;

import de.fhg.iese.dd.platform.api.framework.clientmodel.ClientBaseEntity;
import de.fhg.iese.dd.platform.api.participants.person.clientmodel.ClientPersonReferenceWithEmail;
import de.fhg.iese.dd.platform.api.participants.tenant.clientmodel.ClientCommunity;
import de.fhg.iese.dd.platform.datamanagement.shared.usergeneratedcontentflags.model.enums.UserGeneratedContentFlagStatus;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.SuperBuilder;

@Getter
@Setter
@SuperBuilder
@NoArgsConstructor
public class ClientUserGeneratedContentFlag extends ClientBaseEntity {

    private String entityId;

    @ApiModelProperty(notes = "Fully qualified java class name")
    private String entityType;

    @ApiModelProperty(notes = "might be null for flagged entities not associated with a Person.")
    private ClientPersonReferenceWithEmail entityAuthor;

    @ApiModelProperty(notes = "might be null for autogenerated flags")
    private ClientPersonReferenceWithEmail flagCreator;

    @ApiModelProperty("can be null")
    private ClientCommunity tenant;

    private UserGeneratedContentFlagStatus status;

    private long lastStatusUpdate;

    private ClientUserGeneratedContentFlagStatusRecord lastStatusRecord;

}
